#include <stdlib.h>
#include <stdio.h>
#include <math.h>

//argv[1]Flist file name
//argv[2]Fnode number which starts searching

int *ll,*lr,*linenum;
int *prenum,*far;

int *stack;

int maxpo=1,minpo=1;//coloring : SCC

int maximum(int a,int b);

int main(int argc, char *argv[])
{
	int i,j,init;
	int Line;
	int max=0;
	int x,y;
	
	int *filter;
	
	//read list
	FILE *fp;
	
	ll=(int *)calloc(1,sizeof(int));
	lr=(int *)calloc(1,sizeof(int));
	
	Line=1;
	
	fp=fopen(argv[1],"r");
	while(fscanf(fp,"%d %d",&x,&y)!=EOF)
	{
	max=maximum(max,x);
	max=maximum(max,y);
	ll=(int *)realloc(ll,(Line+1)*sizeof(int));
	lr=(int *)realloc(lr,(Line+1)*sizeof(int));
	ll[Line]=x;
	lr[Line]=y;
	Line++;
	}
	fclose(fp);
	//finish reading list
	
	max++;
	filter=(int *)calloc(max,sizeof(int));
	far=(int *)calloc(max,sizeof(int));
	for(i=1;i<Line;i++)
	{
	filter[ll[i]]=1;
	filter[lr[i]]=1;
	}
	
	//line which node i starts
	linenum=(int *)calloc(max+1,sizeof(int));
	for(i=1;i<Line;i++)
	{
		if(ll[i] != ll[i-1])
		{
			linenum[ll[i]]=i;
			if(ll[i] - ll[i-1] >1)
			{
				for(j=ll[i-1]+1;j<ll[i];j++)
				{
					linenum[j]=linenum[ll[i]];
				}
			}
		}
	}
	linenum[ll[Line-1]+1]=Line;
	//node i 
	
	/////depth-first search/////
	
	prenum=(int *)calloc(max,sizeof(int));
	stack=(int *)calloc(max,sizeof(int));
	
	//not yet
	for(i=1;i<max;i++)
	{
		prenum[i]=-1;
	}
	
		init=atoi(argv[2]);
		if(prenum[init]==-1 && filter[init]>0)
		{
			dfs(init);
			maxpo=0;
			minpo=0;
		}
	if(filter[init]>0)
	{
	for(i=1;i<Line;i++)
	{
		
		if(far[ll[i]]>0 && far[ll[i]]<far[lr[i]] && far[lr[i]]<atoi(argv[3])+1)
		{
		printf("%d %d\n",ll[i],lr[i]);
		}
	}
	}
	
	//}
	
	////count/////
	
	free(filter);
	free(stack);
	free(prenum);
	free(linenum);
	free(far);
	free(ll);
	free(lr);
	
}

////Maximum/////

int maximum(int aa,int bb)
{
	if(aa>bb)
	{
		return(aa);
	}else{
		return(bb);
	}

}

/////Minimum/////

int minimum(int aa,int bb)
{
	if(aa<bb)
	{
		return(aa);
	}else{
		return(bb);
	}

}

/////dfs function/////

dfs(int k)
{
	far[k]=0;
	int t;
	prenum[k]=1;
	stack[maxpo]=k;
	maxpo++;
	
	while(maxpo!=minpo)
	{
	minpo++;
	for(t=linenum[stack[minpo-1]];t<linenum[stack[minpo-1]+1];t++)
		{
			if(prenum[lr[t]]==-1)
			{
			prenum[lr[t]]=1;
			stack[maxpo]=lr[t];
			far[lr[t]]=far[stack[minpo-1]]+1;
			maxpo++;
			}
		}
	}
}
